<?php
/** 
 * Plugin 'act_redct' for the 'ameos_formidable' extension.
 *
 * @author	Jerome Schneider <typo3dev@ameos.com>
 */


require_once(PATH_t3lib . "class.t3lib_htmlmail.php");

class tx_actredct extends formidable_mainactionlet {
	
	function _doTheMagic($aRendered, $sForm) {
		
		$url = null;
		
		if($this->oForm->oDataHandler->_allIsValid()) {
			
			if(($mPage = $this->_navConf("/pageid")) !== FALSE) {
				
				if($this->oForm->isUserObj($mPage)) {
					$mPage = $this->oForm->_callUserObj($mPage);
				}

				$url = t3lib_div::getIndpEnv("TYPO3_SITE_URL") .
					$this->oForm->_oParent->pi_getPageLink(
						$mPage,
						"_self",
						array()
					);

			} else {
				
				$aUserObj = $this->_navConf("/url/userobj");
				
				if($aUserObj !== FALSE) {
					$url = $this->oForm->_callUserObj($this->_navConf("/url/"));
				} else {
					$url = $this->_navConf("/url/");
				}
			}

			if(!is_null($url)) {
				header("Location: " . $url);
				exit();
			}
		}
	}
}


	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/act_redct/api/class.tx_actredct.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/act_redct/api/class.tx_actredct.php"]);
	}

?>