<?php
/** 
 * Plugin 'dh_std' for the 'ameos_formidable' extension.
 *
 * @author	Jerome Schneider <typo3dev@ameos.com>
 */


class tx_dhstd extends formidable_maindatahandler {
	
	function _doTheMagic($bShouldProcess = TRUE) {
		
		if($bShouldProcess && $this->_allIsValid()) {
			
			$aFormData = $this->_getFormDataManaged();
			
			reset($aFormData);
			while(list($elementname, $value) = each($aFormData)) {

				$oRenderlet = $this->oForm->aORenderlets[$elementname];
				//$aRs[$elementname] = $oRenderlet->_fromRenderletToDataHandler($value);
				$aRs[$elementname] = $oRenderlet->_flatten($value);
			}
			
			$this->oForm->_debug(array("RAW DATA" => $aFormData, "TREATED DATA" => $aRs), "DATAHANDLER STANDARD - EXECUTION");
		}
	}
}


	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/dh_std/api/class.tx_dhstd.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/dh_std/api/class.tx_dhstd.php"]);
	}
?>