<?php

	class formidable_maindatasource extends formidable_mainobject {
		
		function _getRecordWindow($iPage, $iRowsPerPage, $bMax = FALSE) {
			
			$iOffset = ($iPage) * $iRowsPerPage;	// counting the offset
			$iNbDisplayed = $iRowsPerPage;
			
			if($bMax !== FALSE) {
				
				if($bMax !== FALSE && (($iOffset + $iRowsPerPage) > $bMax)) {
					$iNbDisplayed = $bMax - $iOffset;
				}
			}
			
			return array(
				"sql"			=> ($iNbDisplayed != "") ? " LIMIT " . $iOffset . ", " . $iNbDisplayed . " " : "",
				"page"			=> $iPage,
				"offset"		=> $iOffset,
				"rowsperpage"	=> $iRowsPerPage,
				"nbdisplayed"	=> $iNbDisplayed,
			);
		}

		function _getTotalNumberOfPages($iRowsPerPage, $iNbRows, $iMaximum = FALSE) {
			
			if($iMaximum !== FALSE && $iNbRows > $iMaximum) {
				$iNbRows = $iMaximum;
			}
			
			return ceil($iNbRows/ $iRowsPerPage);
		}
	}
	
	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/class.maindatasource.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/class.maindatasource.php"]);
	}
?>