<?php
/** 
 * Plugin 'rdt_flexpload' for the 'ameos_formidable' extension.
 *
 * @author	Jerome Schneider <typo3dev@ameos.com>
 */


class tx_rdtflexpload extends formidable_mainrenderlet {

	var $sMajixClass = "Flexpload";
	var $aLibs = array(
		"rdt_flexpload_class" => "res/js/flexpload.js",
	);

	function _render() {

		$sLabel = $this->oForm->_getLLLabel($this->aElement["label"]);
		$sValue = $this->oForm->oDataHandler->getThisFormData($this->_getName());

		$sInput = "<div id=\"" . $this->_getElementHtmlId() . "\" " . $this->_getAddInputParams() . "></div>";
		$sUploadQueue = "<ul id=\"" . $this->_getElementHtmlId() . "_uploadqueue\"></ul>";

		return array(
			"__compiled" => $this->_displayLabel($sLabel) . $sInput . $sUploadQueue,
			"input" => $sInput,
			"uploadqueue" => $sUploadQueue,
		);
	}
}


	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_flexpload/api/class.tx_rdtflexpload.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_flexpload/api/class.tx_rdtflexpload.php"]);
	}
?>