<?php
/** 
 * Plugin 'rdt_box' for the 'ameos_formidable' extension.
 *
 * @author	Jerome Schneider <typo3dev@ameos.com>
 */


class tx_rdtmodalbox extends formidable_mainrenderlet {
	
	var $aLibs = array(
		"rdt_modalbox_class" => "res/js/modalbox.js",
	);

	var $sMajixClass = "ModalBox";

	function _render()			{ return "";}
	function _renderReadOnly()	{ return $this->_render();}
	function _readOnly()		{ return TRUE;}
	function _renderOnly()		{ return TRUE;}
	function mayHaveChilds()	{ return TRUE;}

	function majixShowFreshBox($aConfig = array(), $aTags = array()) {

		$this->initChilds(
			TRUE	// existing renderlets in $this->oForm->aORenderlets will be overwritten
		);	// re-init childs before rendering

		$this->oForm->oDataHandler->refreshAllData();

		return $this->majixShowBox($aConfig, $aTags);
	}
	
	function majixShowBox($aConfig = array(), $aTags = array()) {

		if($this->oForm->__getEnvExecMode() !== "EID") {
			$bOldValue = $this->oForm->bInlineEvents;
			$this->oForm->bInlineEvents = TRUE;
		}

		$aChildsBag = $this->renderChildsBag();
		$aChildsBag = t3lib_div::array_merge_recursive_overrule($aChildsBag, $aTags);

		if($this->oForm->__getEnvExecMode() !== "EID") {
			$this->oForm->bInlineEvents = $bOldValue;
		}

		$sCompiledChilds = $this->renderChildsCompiled(
			$aChildsBag
		);

		$aConfig["html"] = $sCompiledChilds;

		return $this->buildMajixExecuter(
			"showBox",
			$aConfig
		);
	}

	function majixCloseBox() {

		return $this->buildMajixExecuter(
			"closeBox"
		);
	}

	function loadModalBox(&$oForm) {
		$oForm->oJs->loadScriptaculous();
		//$this->loadNiftyCube();

		$sPath = t3lib_div::getIndpEnv("TYPO3_SITE_URL") . t3lib_extMgm::siteRelPath("ameos_formidable") . "api/base/rdt_modalbox/res/js/modalbox.js";

		$oForm->additionalHeaderData(
			"<script type=\"text/javascript\" src=\"" . $sPath . "\"></script>",
			"rdt_modalbox_class"
		);
	}

	// this has to be static !!!
	function loaded(&$aParams) {
		tx_rdtmodalbox::loadModalBox($aParams["form"]);
	}
}


	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_modalbox/api/class.tx_rdtmodalbox.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/base/rdt_modalbox/api/class.tx_rdtmodalbox.php"]);
	}

?>