<?php

	class formidable_mainobject {

		var $oForm			= null;
		var $aElement		= null;
		var $sExtPath		= null;
		var $sExtRelPath	= null;
		var $sExtWebPath	= null;
		var $aObjectType	= null;
		
		var $sXPath			= null;

		function _init(&$oForm, $aElement, $aObjectType, $sXPath) {
			
			$this->oForm =& $oForm;
			$this->aElement = $aElement;
			$this->aObjectType = $aObjectType;

			$this->sExtPath = $aObjectType["PATH"];
			$this->sExtRelPath = $aObjectType["RELPATH"];
			$this->sExtWebPath = t3lib_div::getIndpEnv("TYPO3_SITE_URL") . $this->sExtRelPath;

			$this->sXPath = $sXPath;

			if(is_array($this->oForm->conf[$aObjectType["OBJECT"] . "."]) && array_key_exists($aObjectType["EXTKEY"] . ".", $this->oForm->conf[$aObjectType["OBJECT"] . "."])) {
				$this->conf = $this->oForm->conf[$aObjectType["OBJECT"] . "."][$aObjectType["EXTKEY"] . "."];
			} else {
				$this->conf = array();
			}
		}

		function _getType() {
			return $this->aElement["type"];
		}

		function _navConf($sPath) {
			return $this->oForm->_navConf($sPath, $this->aElement);
		}

		/**
		 * [Describe function...]
		 *
		 * @param	[type]		$sPath: ...
		 * @param	[type]		$aConf: ...
		 * @return	[type]		...
		 */
		function _isTrue($sPath) {

			return $this->_isTrueVal(
				$this->_navConf(
					$sPath
				)
			);

		}

		/**
		 * [Describe function...]
		 *
		 * @param	[type]		$sPath: ...
		 * @param	[type]		$aConf: ...
		 * @return	[type]		...
		 */
		function _isFalse($sPath) {

			$mValue = $this->_navConf($sPath);

			if($mValue !== FALSE) {
				return $this->_isFalseVal($mValue);
			} else {
				return FALSE;	// if not found in conf, the searched value is not FALSE, so _isFalse() returns FALSE !!!!
			}
		}

		/**
		 * [Describe function...]
		 *
		 * @param	[type]		$mVal: ...
		 * @return	[type]		...
		 */
		function _isTrueVal($mVal) {

			if($this->oForm->isUserObj($mVal)) {
				$mVal = $this->oForm->_callUserObj($mVal);
			}

			return (($mVal === TRUE) || ($mVal == "1") || (strtoupper($mVal) == "TRUE"));
		}

		/**
		 * [Describe function...]
		 *
		 * @param	[type]		$mVal: ...
		 * @return	[type]		...
		 */
		function _isFalseVal($mVal) {

			if($this->oForm->isUserObj($mVal)) {
				$mVal = $this->oForm->_callUserObj($mVal);
			}

			return (($mVal == FALSE) || (strtoupper($mVal) == "FALSE"));
		}

		/**
		 * [Describe function...]
		 *
		 * @param	[type]		$sPath: ...
		 * @param	[type]		$aConf: ...
		 * @return	[type]		...
		 */
		function _defaultTrue($sPath) {

			if($this->_navConf($sPath) !== FALSE) {
				return $this->_isTrue($sPath);
			} else {
				return TRUE;	// TRUE as a default
			}
		}

		/**
		 * [Describe function...]
		 *
		 * @param	[type]		$sPath: ...
		 * @param	[type]		$aConf: ...
		 * @return	[type]		...
		 */
		function _defaultFalse($sPath) {

			if($this->_navConf($sPath) !== FALSE) {
				return $this->_isTrue($sPath);
			} else {
				return FALSE;	// FALSE as a default
			}
		}




		// this has to be static !!!
		function loaded(&$aParams) {
		}

		function cleanBeforeSession() {
			unset($this->oForm);
		}
	}
	
	if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/class.mainobject.php"])	{
		include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/ameos_formidable/api/class.mainobject.php"]);
	}
?>